/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/Classes/Class.java to edit this template
 */
package actividad31.Aplicaciones;

import actividad31.Actividad31;
import actividad31.Drivers.Terminal;
import actividad31.Interfaces.Terminalnterfaz;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.net.Socket;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author kyman
 */
public class Cliente implements Terminalnterfaz {
    
    private Socket socket;
    private PrintWriter salida;
    
    public Cliente(){
        System.out.println("Lanzando cliente.");
        
        try{
            
            socket = new Socket(Actividad31.host, Actividad31.puerto);
            BufferedReader lectura = new BufferedReader(new InputStreamReader(socket.getInputStream()));
            salida = new PrintWriter(socket.getOutputStream());
            
            new Thread(new Runnable(){
                @Override
                public void run() {
                    
                    String mensaje;
                    
                    try {
                        while((mensaje = lectura.readLine()) != null)
                            System.out.println(mensaje);
                    } catch (IOException excepcion) {
                        Actividad31.excepcion(excepcion);
                    }
                    
                    Actividad31.cerrar();

                }
            }).start();
            
        } catch (IOException excepcion) {
            // Actividad31.excepcion(excepcion);
            System.out.println("No se pudo conectar contra el servidor '" + Actividad31.host + ":" + Actividad31.puerto + ". Comprueba que el servidor esté lanzado en ese host.");
            Actividad31.cerrar();
        }
        
    }

    @Override
    public boolean terminal(String comando) {
        
        boolean estado = false;
        
        try{
            
            int numero = Integer.parseInt(comando);
            
            enviar("" + numero);
            estado = true;
            
        }catch(Exception excepcion){}
        
        return estado;
    }

    @Override
    public void cerrar() {
        
        try {
            if(salida != null)
                salida.close();
            socket.close();
        } catch (IOException excepcion) {
            Actividad31.excepcion(excepcion);
        }
        
    }
    
    public boolean enviar(String mensaje){
        
        boolean estado = false;
        
        try{
            new Thread(new Runnable(){
                @Override
                public void run() {
                    salida.println(mensaje);
                    salida.flush();
                }
            }).start();
        }catch(Exception excepcion){
            Actividad31.excepcion(excepcion);
        }
        
        return estado;
    }
    
}
