/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/Classes/Class.java to edit this template
 */
package actividad31.Aplicaciones;

import actividad31.Actividad31;
import actividad31.Drivers.Terminal;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.net.ServerSocket;
import java.net.Socket;
import java.util.ArrayList;
import actividad31.Interfaces.Terminalnterfaz;

/**
 *
 * @author kyman
 */
public class Servidor implements Terminalnterfaz {
    
    private ServerSocket socket;
    private ArrayList<Socket> clientes = new ArrayList<>();
    private ArrayList<PrintWriter> salidas = new ArrayList<>();
    private int numero_aleatorio = 0;
    
    public Servidor(){
        System.out.println("Lanzando el servidor.");
        
        new Thread(new Runnable(){
            @Override
            public void run() {
                try{
                    
                    socket = new ServerSocket(Actividad31.puerto);
                    
                    while(Actividad31.trabajando){
                        
                        Socket cliente = socket.accept();
                        int i = 0;
                        int l = clientes.size();
                        PrintWriter salida = new PrintWriter(cliente.getOutputStream());
                        
                        for(; i < l; i ++)
                            if(clientes.get(i) == null)
                                break;
                        
                        if(i == l){
                            clientes.add(cliente);
                            salidas.add(salida);
                        }else{
                            clientes.set(i, cliente);
                            salidas.set(i, salida);
                        }
                        
                        System.out.println("Escuchando al cliente '" + i + "'.");
                        
                        escuchar(i, new BufferedReader(new InputStreamReader(cliente.getInputStream())));
                        
                    }
                    
                } catch (IOException excepcion) {
                    Actividad31.excepcion(excepcion);
                    Actividad31.cerrar();
                }
            }
            
        }).start();
        
    }

    @Override
    public boolean terminal(String comando) {
        
        boolean estado = true;
        
        switch(comando){
            case "regenerar" -> {
                numero_aleatorio = (int)(Math.random() * (Actividad31.rango_aleatorio[1] + 1 - Actividad31.rango_aleatorio[0])) - Actividad31.rango_aleatorio[0];
                System.out.println("El nuevo número aleatorio es '" + numero_aleatorio + "'.");
            }
            default -> estado = false;
        }
        
        return estado;
    }

    @Override
    public void cerrar() {
        
        for(int i = 0, l = clientes.size(); i < l; i ++){
           
            Socket cliente = clientes.get(i);

            if(cliente != null){
                
                PrintWriter salida = salidas.get(i);
                
                try {
                    
                    if(salida != null){
                        salida.close();
                        salidas.set(i, null);
                    }
                    
                    cliente.close();
                    clientes.set(i, null);
                    
                } catch (IOException excepcion) {
                    Actividad31.excepcion(excepcion);
                }

            }
                
        }
                
        try{
            socket.close();
        } catch (IOException excepcion) {
            Actividad31.excepcion(excepcion);
        }     
        
    }
    
    public boolean enviar(int i, String mensaje){
        
        boolean exito = false;
        PrintWriter salida;
        
        try{
            salida = salidas.get(i);
            new Thread(new Runnable() {
                @Override
                public void run() {
                    salida.println(mensaje);
                    salida.flush();
                }
            }).start();
            exito = true;
        }catch(Exception excepcion){
            Actividad31.excepcion(excepcion);
        }
        
        return exito;
    }
    
    private void escuchar(int i, BufferedReader entrada){
        new Thread(new Runnable() {
            @Override
            public void run() {
                
                String mensaje;
                
                try{
                    while((mensaje = entrada.readLine()) != null)
                        switch(mensaje){
                            default -> {
                                try{
                                    
                                    int valor = Integer.parseInt(mensaje.trim());
                                    
                                    if(valor == numero_aleatorio)
                                        enviar(i, "¡¡Has acertado!! El número es " + valor + ".");
                                    else if(valor < numero_aleatorio)
                                        enviar(i, "El número es mayor que '" + valor + "'.");
                                    else 
                                        enviar(i, "El número es menor que '" + valor + "'.");
                                    
                                }catch(Exception excepcion){
                                    Actividad31.excepcion(excepcion);
                                }
                            }
                        }
                    entrada.close();
                } catch (IOException excepcion) {
                    Actividad31.excepcion(excepcion);
                }
            }
        }).start();
    }
    
}
